unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  mapa: array[0..255, 0..255] of char;
  soubor:string;
  a,b : integer;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
s:string;
i, i2, delka_radku:integer;
StringList:Tstrings;
begin

 StringList := TStringList.Create;

 If OpenDialog1.Execute then begin
  s := OpenDialog1.filename;
  Edit1.Text := ExtractFileName(s);
 end;

 StringList.LoadFromFile(s);

 a := StringList.Count-1;
 b := length(StringList.Strings[1])-1;

 if (a > 255) or (b > 255) then begin
  ShowMessage('Soubor je moc velk');
  exit;
 end;


 Delka_radku := Length(StringList.strings[0]);

   For i:= 0 to stringlist.Count-1 do begin
     If delka_radku <> Length(StringList.strings[i]) then begin
      ShowMessage('Soubor nem vechny dky stejn!');
      exit;
     end;
   end;

 SetLength(mapa,StringList.Count);

 For i := 0 to StringList.Count-1 do begin
   For i2 := 0 to length(StringList.Strings[i])-1 do begin
     SetLength(mapa[i],length(StringList.Strings[i2])-1);
     mapa[i,i2] := StringList.strings[i][i2];
   end;
 end;

 StringList.free;

 button4.Enabled := true;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  application.Terminate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Form2.visible := true;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
i, i2:integer;
barva:TColor;
begin

 Image1.Canvas.Brush.Color := clWhite;
 Image1.Canvas.Pen.Color := clWhite;
 Image1.Canvas.Rectangle(0,0,417,447);


 for i := 0 to a do begin
    For i2 := 0 to b do begin

      If Uppercase(mapa[i,i2]) = 'X' then begin
        barva := clblack;
      end;

      If Uppercase(mapa[i,i2]) = 'S' then begin
        barva := clAqua;
      end;

      If Uppercase(mapa[i,i2]) = ':' then begin
        barva := clgreen;
      end;

      If Uppercase(mapa[i,i2]) = 'C' then begin
        barva := clFuchsia;
      end;

      If Uppercase(mapa[i,i2]) = '.' then begin
        barva := cllime;
      end;

        Image1.Canvas.Brush.Color := barva;
        Image1.Canvas.Pen.Color := barva;
        Image1.Canvas.Rectangle(i*(417 div a),i2*(417 div b),i*(417 div a)+15,i2*(417 div a)+15);
    end;
 end;

 button4.Enabled := false;
 
end;

end.
